#include <bindings.dsl.h>
#include <apr_user.h>

module Bindings.APR.User where
#strict_import
import Bindings.APR.ErrNo
import Bindings.APR.Pools

#integral_t apr_uid_t
#integral_t apr_gid_t

#if APR_HAS_USER

#  ccall   apr_uid_current     , Ptr <apr_uid_t> -> Ptr <apr_gid_t> -> Ptr <apr_pool_t> -> IO <apr_status_t>
#  ccall   apr_uid_name_get    , Ptr (Ptr CChar) -> <apr_uid_t> -> Ptr <apr_pool_t> -> IO <apr_status_t>
#  ccall   apr_uid_get         , Ptr <apr_uid_t> -> Ptr <apr_gid_t> -> Ptr CChar -> Ptr <apr_pool_t> -> IO <apr_status_t>
#  ccall   apr_uid_homepath_get, Ptr (Ptr CChar) -> Ptr CChar -> Ptr <apr_pool_t> -> IO <apr_status_t>
#  cinline apr_uid_compare     , <apr_uid_t> -> <apr_uid_t> -> IO <apr_status_t>

#  ccall   apr_gid_name_get    , Ptr (Ptr CChar) -> <apr_gid_t> -> Ptr <apr_pool_t> -> IO <apr_status_t>
#  ccall   apr_gid_get         , Ptr <apr_gid_t> -> Ptr CChar -> Ptr <apr_pool_t> -> IO <apr_status_t>
#  cinline apr_gid_compare     , <apr_gid_t> -> <apr_gid_t> -> IO <apr_status_t>

#endif